--Song for the Noble Dead
function c143.initial_effect(c)
	--Activate
	local e1=Effect.CreateEffect(c)
	e1:SetType(EFFECT_TYPE_ACTIVATE)
	e1:SetCode(EVENT_FREE_CHAIN)
	e1:SetCondition(c143.condition)
	e1:SetOperation(c143.operation)
	c:RegisterEffect(e1)
end
function c143.condition(e,tp,eg,ep,ev,re,r,rp)
	return Duel.GetCurrentPhase()==PHASE_MAIN1 and not Duel.CheckPhaseActivity()
end
function c143.operation(e,tp,eg,ep,ev,re,r,rp)
	local e4=Effect.CreateEffect(e:GetHandler())
	e4:SetType(EFFECT_TYPE_FIELD)
	e4:SetCode(EFFECT_CANNOT_REMOVE)
	e4:SetReset(RESET_PHASE+PHASE_END,2)
	e4:SetTargetRange(LOCATION_GRAVE,0)
	e4:SetCondition(c143.contp)
	Duel.RegisterEffect(e4,tp)
	local e5=e4:Clone()
	e5:SetTargetRange(0,LOCATION_GRAVE)
	e5:SetCondition(c143.conntp)
	Duel.RegisterEffect(e5,tp)
	local e6=Effect.CreateEffect(e:GetHandler())
	e6:SetType(EFFECT_TYPE_FIELD)
	e6:SetCode(EFFECT_NECRO_VALLEY)
	e6:SetReset(RESET_PHASE+PHASE_END,2)
	e6:SetTargetRange(LOCATION_GRAVE,0)
	e6:SetCondition(c143.contp)
	Duel.RegisterEffect(e6,tp)
	local e7=e6:Clone()
	e7:SetTargetRange(0,LOCATION_GRAVE)
	e7:SetCondition(c143.conntp)
	Duel.RegisterEffect(e7,tp)
	local e8=Effect.CreateEffect(e:GetHandler())
	e8:SetType(EFFECT_TYPE_FIELD)
	e8:SetCode(EFFECT_NECRO_VALLEY)
	e8:SetReset(RESET_PHASE+PHASE_END,2)
	e8:SetProperty(EFFECT_FLAG_PLAYER_TARGET)
	e8:SetTargetRange(1,0)
	e8:SetCondition(c143.contp)
	Duel.RegisterEffect(e8,tp)
	local e9=e8:Clone()
	e9:SetTargetRange(0,1)
	e9:SetCondition(c143.conntp)
	Duel.RegisterEffect(e9,tp)
	local e10=Effect.CreateEffect(e:GetHandler())
	e10:SetType(EFFECT_TYPE_FIELD+EFFECT_TYPE_CONTINUOUS)
	e10:SetCode(EVENT_CHAIN_SOLVING)
	e10:SetReset(RESET_PHASE+PHASE_END,2)
	e10:SetOperation(c143.disop)
	Duel.RegisterEffect(e10,tp)
end
function c143.contp(e)
	return not Duel.IsPlayerAffectedByEffect(e:GetHandler():GetControler(),EFFECT_NECRO_VALLEY_IM)
end
function c143.conntp(e)
	return not Duel.IsPlayerAffectedByEffect(1-e:GetHandler():GetControler(),EFFECT_NECRO_VALLEY_IM)
end
function c143.disfilter(c,im0,im1)
	if c:IsControler(0) then return im0 and c:IsHasEffect(EFFECT_NECRO_VALLEY)
	else return im1 and c:IsHasEffect(EFFECT_NECRO_VALLEY) end
end
function c143.discheck(ev,category,re,im0,im1)
	local ex,tg,ct,p,v=Duel.GetOperationInfo(ev,category)
	if not ex then return false end
	if v==LOCATION_GRAVE then
		if p==0 then return im0
		elseif p==1 then return im1
		elseif p==PLAYER_ALL then return im0 and im1
		end
	end
	if tg and tg:GetCount()>0 then
		return tg:IsExists(c143.disfilter,1,nil,im0,im1)
	end
	return false
end
function c143.disop(e,tp,eg,ep,ev,re,r,rp)
	local tc=re:GetHandler()
	if not Duel.IsChainDisablable(ev) or tc:IsHasEffect(EFFECT_NECRO_VALLEY_IM) then return end
	local res=false
	local im0=not Duel.IsPlayerAffectedByEffect(0,EFFECT_NECRO_VALLEY_IM)
	local im1=not Duel.IsPlayerAffectedByEffect(1,EFFECT_NECRO_VALLEY_IM)
	if not res and c143.discheck(ev,CATEGORY_SPECIAL_SUMMON,re,im0,im1) then res=true end
	if not res and c143.discheck(ev,CATEGORY_REMOVE,re,im0,im1) then res=true end
	if not res and c143.discheck(ev,CATEGORY_TOHAND,re,im0,im1) then res=true end
	if not res and c143.discheck(ev,CATEGORY_TODECK,re,im0,im1) then res=true end
	if not res and c143.discheck(ev,CATEGORY_LEAVE_GRAVE,re,im0,im1) then res=true end
	if res then Duel.NegateEffect(ev) end
end
