--Shining Arc in the Dark
function c251.initial_effect(c)
--Activate
	local e1=Effect.CreateEffect(c)
	e1:SetCategory(CATEGORY_SPECIAL_SUMMON)
	e1:SetType(EFFECT_TYPE_ACTIVATE)
	e1:SetCode(EVENT_FREE_CHAIN)
	e1:SetProperty(EFFECT_FLAG_CARD_TARGET)
	e1:SetCondition(c251.condition)
	e1:SetTarget(c251.target)
	e1:SetOperation(c251.activate)
	c:RegisterEffect(e1)
end
function c251.condition(e,tp,eg,ep,ev,re,r,rp)
	return Duel.GetFieldCard(tp,LOCATION_SZONE,6) and Duel.GetFieldCard(tp,LOCATION_SZONE,7)
end
function c251.filter(c,lsc,rsc)
	local lv=c:GetLevel()
	return lv>lsc and lv<rsc 
end
function c251.target(e,tp,eg,ep,ev,re,r,rp,chk,chkc)
	local lsc=Duel.GetFieldCard(tp,LOCATION_SZONE,6):GetLeftScale()
	local rsc=Duel.GetFieldCard(tp,LOCATION_SZONE,7):GetRightScale()
	if lsc>rsc then lsc,rsc=rsc,lsc end
	if chkc then return chkc:IsLocation(LOCATION_GRAVE) and chkc:IsControler(tp) and c251.filter(chkc,lsc,rsc) end
	if chk==0 then return Duel.IsExistingTarget(c251.filter,tp,LOCATION_GRAVE,0,1,nil,lsc,rsc) end
	Duel.Hint(HINT_SELECTMSG,tp,HINTMSG_SPSUMMON)
	local g=Duel.SelectTarget(tp,c251.filter,tp,LOCATION_GRAVE,0,1,1,nil,lsc,rsc)
	Duel.SetOperationInfo(0,CATEGORY_SPECIAL_SUMMON,g,1,0,0)
end
function c251.activate(e,tp,eg,ep,ev,re,r,rp)
	local g=Duel.GetChainInfo(0,CHAININFO_TARGET_CARDS)
	local sg=g:Filter(Card.IsRelateToEffect,nil,e)
	if sg:GetCount()>0 then
		 Duel.SpecialSummon(sg,0,tp,tp,true,false,POS_FACEUP)
	end
end
